import asyncio

from federated_catalogue.infra.spi.message_queue.redis import Publisher


async def send_message(vp):
    publisher = Publisher(url="redis://127.0.0.1:6379/1", channel_name="catalogue/1")
    await publisher.publish(vp)
    await asyncio.sleep(0.1)


if __name__ == "__main__":
    vp = '{"@context": ["https://www.w3.org/2018/credentials/v1"], "@id": "urn:uuid:4ce41248-d860-45d7-8788-698a7bd44799", "@type": ["VerifiablePresentation"], "proof": {"jws": "eyJhbGciOiJQUzI1NiIsImI2NCI6ZmFsc2UsImNyaXQiOlsiYjY0Il19..N-VbQ63oXpdF_bIbLFeqbE36I9Dbc1yRIRRQUESI_ag0ya7Ntqfl4Oq6kpyGAdADnQ-MNXMFOx-GHhMghhPeAegfLfe2a-ohattIVi2HlKg-2Blcx3-S7wNUQmnxmZAtuUeri7ffWVe1jJbYvaH8jGKqIrcIxTfRdAB7LI26Q9fP5Allk4NrlIabmbWT8Sp7aANr7uzxFsiPag0WZ4HJO3SyTbxRh4JEASTwxu99JWUgsh7Wk0cG0IufyL7VfVwTHuFTrVhZlsgoUw7u1ei6nKK69YXu786V02NvXLqBBkx0NR8X9DisnzaMC10n5rlITO5RBzDWLcifWooCh89nnQ", "proofPurpose": "assertionMethod", "type": "JsonWebSignature2020", "verificationMethod": "did:web:dufourstorage.provider.dev.gaiax.ovh"}, "verifiableCredential": [{"@context": ["https://www.w3.org/2018/credentials/v1", "https://w3id.org/security/suites/jws-2020/v1", "https://schemas.abc-federation.gaia-x.community/wip/contexts/for-credentials.json"], "@id": "did:web:dufourstorage.provider.dev.gaiax.ovh:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/vc/4db6c47d6120ec751ae3f960c2b3775aed475b6e68a22de38ea91d7e660f6682/data.json", "@type": ["VerifiableCredential", "Catalogue"], "credentialSubject": {"@context": {"@vocab": "gx:Catalogue/", "gx": "https://w3id.org/gaia-x/", "schema": "https://schema.org/"}, "@type": "Catalogue", "getVerifiableCredentialsIDs": ["did:web:dufourstorage.provider.dev.gaiax.ovh:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/vc/1857fc11d2e76e3605a264a1a2e0b260615c339783cd974d53fb4c237575126e/data.json"], "providedBy": "did:web:dufourstorage.provider.dev.gaiax.ovh:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/data.json"}, "issuanceDate": "2023-06-13T12:55:21.575151+00:00", "issuer": "did:web:dufourstorage.provider.dev.gaiax.ovh", "proof": {"created": "2023-06-13T12:55:21.575151+00:00", "jws": "eyJhbGciOiJQUzI1NiIsImI2NCI6ZmFsc2UsImNyaXQiOlsiYjY0Il19..ooebuSKEiG4R0_UXbVRBLWnhncV8f3Luy5x4SQcnAWdf2dT1az8fRuzC5JTaFEtCoCNkZRcyxt1sPraJ3sUbFRzI5T5VjkmIpookv4TuSG_fIfm_LvOlM2uxoFKC9r9NnYgd8HpyulzfFXISw4CdrIszheKnBGnzRdfMd5CEPlyYF2fL2j3WYt_LkqA9Tj8p9Gw4N5o2T_5VFnaGMQmTN1vQsuMNNRt67hrqIOy8RVilBuxo-WLDHM01WvgojfqkwMJE6VJC7qWG13i34dIw7rSLyWzYstWT8aaHzOFkA9sLeW3Uu04eun4QL6EA7cvxQC_89p7eLYkm_CBCLtzwqA", "proofPurpose": "assertionMethod", "type": "JsonWebSignature2020", "verificationMethod": "did:web:dufourstorage.provider.dev.gaiax.ovh"}}]}'
    # vp = '{"@context": ["https://www.w3.org/2018/credentials/v1"], "@id": "urn:uuid:4ce41248-d860-45d7-8788-698a7bd44799", "@type": ["VerifiablePresentation"], "proof": {"jws": "eyJhbGciOiJQUzI1NiIsImI2NCI6ZmFsc2UsImNyaXQiOlsiYjY0Il19..N-VbQ63oXpdF_bIbLFeqbE36I9Dbc1yRIRRQUESI_ag0ya7Ntqfl4Oq6kpyGAdADnQ-MNXMFOx-GHhMghhPeAegfLfe2a-ohattIVi2HlKg-2Blcx3-S7wNUQmnxmZAtuUeri7ffWVe1jJbYvaH8jGKqIrcIxTfRdAB7LI26Q9fP5Allk4NrlIabmbWT8Sp7aANr7uzxFsiPag0WZ4HJO3SyTbxRh4JEASTwxu99JWUgsh7Wk0cG0IufyL7VfVwTHuFTrVhZlsgoUw7u1ei6nKK69YXu786V02NvXLqBBkx0NR8X9DisnzaMC10n5rlITO5RBzDWLcifWooCh89nnQ", "proofPurpose": "assertionMethod", "type": "JsonWebSignature2020", "verificationMethod": "did:web:dufourstorage.provider.dev.gaiax.ovh"}, "verifiableCredential": [{"@context": ["https://www.w3.org/2018/credentials/v1", "https://w3id.org/security/suites/jws-2020/v1", "https://schemas.abc-federation.gaia-x.community/wip/contexts/for-credentials.json"], "@id": "did:web:dufourstorage.provider.dev.gaiax.ovh:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/vc/4db6c47d6120ec751ae3f960c2b3775aed475b6e68a22de38ea91d7e660f6682/data.json", "@type": ["VerifiableCredential", "Catalogue"], "credentialSubject": {"@context": {"@vocab": "gx:Catalogue/", "gx": "https://w3id.org/gaia-x/", "schema": "https://schema.org/"}, "@type": "Catalogue", "providedBy": "did:web:dufourstorage.provider.dev.gaiax.ovh:participant:1225ed1cc7755bc5867413f1ca1cf99eb66d4f7a148e10e346390c4bb302f649/data.json"}, "issuanceDate": "2023-06-13T12:55:21.575151+00:00", "issuer": "did:web:dufourstorage.provider.dev.gaiax.ovh", "proof": {"created": "2023-06-13T12:55:21.575151+00:00", "jws": "eyJhbGciOiJQUzI1NiIsImI2NCI6ZmFsc2UsImNyaXQiOlsiYjY0Il19..ooebuSKEiG4R0_UXbVRBLWnhncV8f3Luy5x4SQcnAWdf2dT1az8fRuzC5JTaFEtCoCNkZRcyxt1sPraJ3sUbFRzI5T5VjkmIpookv4TuSG_fIfm_LvOlM2uxoFKC9r9NnYgd8HpyulzfFXISw4CdrIszheKnBGnzRdfMd5CEPlyYF2fL2j3WYt_LkqA9Tj8p9Gw4N5o2T_5VFnaGMQmTN1vQsuMNNRt67hrqIOy8RVilBuxo-WLDHM01WvgojfqkwMJE6VJC7qWG13i34dIw7rSLyWzYstWT8aaHzOFkA9sLeW3Uu04eun4QL6EA7cvxQC_89p7eLYkm_CBCLtzwqA", "proofPurpose": "assertionMethod", "type": "JsonWebSignature2020", "verificationMethod": "did:web:dufourstorage.provider.dev.gaiax.ovh"}}]}'

    asyncio.run(send_message(vp))
